// Regular Expression Tester v1.0
// Written by David J. Stein, Esq. See "License.html" for terms and conditions of use.

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace Regular_Expression_Tester {

	public class RegularExpressionReference : System.Windows.Forms.Form	{

		#region Variables and initialization code

		private System.Windows.Forms.TextBox txtReference;
		private System.ComponentModel.Container components = null;
		public bool bAlive = true;

		public RegularExpressionReference()	{
			InitializeComponent();
		}

		#endregion

		#region Uninteresting Windows Form Designer generated code
		protected override void Dispose(bool disposing)		{
			if (disposing) {
				if (components != null) {
				components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

	private void InitializeComponent()	{
		System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RegularExpressionReference));
		this.txtReference = new System.Windows.Forms.TextBox();
		this.SuspendLayout();
		// 
		// txtReference
		// 
		this.txtReference.Anchor = ((System.Windows.Forms.AnchorStyles) ((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
														| System.Windows.Forms.AnchorStyles.Left)
														| System.Windows.Forms.AnchorStyles.Right)));
		this.txtReference.Location = new System.Drawing.Point(8, 8);
		this.txtReference.Multiline = true;
		this.txtReference.Name = "txtReference";
		this.txtReference.ReadOnly = true;
		this.txtReference.ScrollBars = System.Windows.Forms.ScrollBars.Both;
		this.txtReference.Size = new System.Drawing.Size(568, 400);
		this.txtReference.TabIndex = 0;
		this.txtReference.Text = "textBox1";
		// 
		// RegularExpressionReference
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(584, 414);
		this.Controls.Add(this.txtReference);
		this.Icon = ((System.Drawing.Icon) (resources.GetObject("$this.Icon")));
		this.MaximizeBox = false;
		this.MinimizeBox = false;
		this.Name = "RegularExpressionReference";
		this.ShowInTaskbar = false;
		this.Text = "Regular Expression Reference";
		this.Closing += new System.ComponentModel.CancelEventHandler(this.RegularExpressionReference_Closing);
		this.Load += new System.EventHandler(this.RegularExpressionReference_Load);
		this.ResumeLayout(false);
		this.PerformLayout();

	}
		#endregion

		#region Event handlers

		private void RegularExpressionReference_Load(object sender, System.EventArgs e) {
			// Amazingly ugly, RTF-formatted text included here - simply because it's easieer than including a separate text file.
			txtReference.Text =
"Regular Expression Reference:\r\n" +
"\r\n" +
"Specific Symbols:\r\n" +
"\r\n" +
"[xyz]\r\n" +
" A character set. Matches any one of the enclosed characters. For example, '[abc]' matches the 'a' in \"plain\".\r\n" +
"\r\n" +
"[^xyz]\r\n" +
"  A negative character set. Matches any character not enclosed. For example, '[^abc]' matches the 'p' in \"plain\".\r\n" +
"\r\n" +
"[a-z]\r\n" +
"  A range of characters. Matches any character in the specified range. For example, '[a-z]' matches any lowercase\r\n" +
"alphabetic character in the range 'a' through 'z'.\r\n" +
"\r\n" +
"[^a-z]\r\n" +
" A negative range characters. Matches any character not in the specified range. For example, '[^a-z]' matches any\r\n" +
"character not in the range 'a' through 'z'.\r\n" +
"\r\n" +
"\\b\r\n" +
"  Matches a word boundary, that is, the position between a word and a space. For example, 'er\\b' matches the\r\n" +
"'er' in \"never\" but not the 'er' in\"verb\".\r\n" +
"\r\n" +
"\\B\r\n" +
"  Matches a nonword boundary. 'er\\B' matches the 'er' in \"verb\" but not the 'er' in \"never\".\r\n" +
"\r\n" +
"\\cx\r\n" +
"  Matches the control character indicated by x. For example, \\cM matches a Control-M or carriage return\r\n" +
"character. The value of x must be in the range of A-Z or a-z. If not, c is assumed to be a literal 'c' character.\r\n" +
" 	   \r\n" +
"\\d\r\n" +
"  Matches a digit character. Equivalent to [0-9].\r\n" +
"\r\n" +
"\\D\r\n" +
"  Matches a nondigit character. Equivalent to [^0-9].\r\n" +
"\r\n" +
"\\f\r\n" +
"  Matches a form-feed character. Equivalent to \\x0c and \\cL.\r\n" +
"\r\n" +
"\\n\r\n" +
"  Matches a newline character. Equivalent to \\x0a and \\cJ.\r\n" +
"\r\n" +
"\\r\r\n" +
"  Matches a carriage return character. Equivalent to \\x0d and \\cM.\r\n" +
"\r\n" +
"\\s\r\n" +
"  Matches any white space character including space, tab, form-feed, and so on. Equivalent to [ \\f\\n\\r\\t\\v].\r\n" +
"\r\n" +
"\\S\r\n" +
"  Matches any non-white space character. Equivalent to [^ \\f\\n\\r\\t\\v].\r\n" +
"\r\n" +
"\\t\r\n" +
"  Matches a tab character. Equivalent to \\x09 and \\cI.\r\n" +
"\r\n" +
"\\v\r\n" +
"  Matches a vertical tab character. Equivalent to \\x0b and \\cK.\r\n" +
"\r\n" +
"\\w\r\n" +
"  Matches any word character including underscore. Equivalent to '[A-Za-z0-9_]'.\r\n" +
"\r\n" +
"\\W\r\n" +
"  Matches any nonword character. Equivalent to '[^A-Za-z0-9_]'.\r\n" +
"\r\n" +
"\\xn\r\n" +
"  Matches n, where n is a hexadecimal escape value. Hexadecimal escape values must be exactly two digits long.\r\n" +
"For example, '\\x41' matches \"A\". '\\x041' is equivalent to '\\x04' & \"1\". Allows ASCII codes to be used in regular\r\n" +
"expressions.\r\n" +
"\r\n" +
"\\num\r\n" +
"  Matches num, where num is a positive integer. A reference back to captured matches. For example, '(.)\\1'\r\n" +
"matches two consecutive identical characters.\r\n" +
"\r\n" +
"\\n\r\n" +
"  Identifies either an octal escape value or a backreference. If \\n is preceded by at least n captured\r\n" +
"subexpressions, n is a backreference. Otherwise, n is an octal escape value if n is an octal digit (0-7).\r\n" +
"\r\n" +
"\\nm\r\n" +
"  Identifies either an octal escape value or a backreference. If \\nm is preceded by at least nm captured\r\n" +
"subexpressions, nm is a backreference. If \\nm is preceded by at least n captures, n is a backreference followed\r\n" +
"by literal m. If neither of the preceding conditions exist, \\nm matches octal escape value nm when n and m are\r\n" +
"octal digits (0-7).\r\n" +
"\r\n" +
"\\nml\r\n" +
"  Matches octal escape value nml when n is an octal digit (0-3) and m and l are octal digits (0-7).\r\n" +
"\r\n" +
"\\un\r\n" +
"  Matches n, where n is a Unicode character expressed as four hexadecimal digits. For example, \\u00A9 matches the\r\n" +
"copyright symbol ().	 \r\n" +
"\r\n" +
"\r\n" +
"Logical Operators:\r\n" +
"\r\n" +
"|\r\n" +
"  Set union; indicates an either/or match between the symbols preceding the operator and the symbols following\r\n" +
"it. Use parentheses to demarcate the borders of the match patterns. For example, 'z|food' matches \"z\" or \"food\",\r\n" +
"and '(z|f)ood' matches \"zood\" or \"food\".\r\n" +
"\r\n" +
"\\\r\n" +
"  Marks the next character as a special character, a literal, a backreference, or an octal escape. For example,\r\n" +
"'n' matches the character \"n\". '\\n' matches a newline character. '\\\\' matches \"\\\", and '\\(' matches \"(\".\r\n" +
"\r\n" +
"^\r\n" +
"  Matches the position at the beginning of the input string. If the RegExp object's Multiline property is set,\r\n" +
"this symbol also matches the position following '\\n' or '\\r'.\r\n" +
"\r\n" +
"$\r\n" +
"  Matches the position at the end of the input string. If the RegExp object's Multiline property is set, $ also\r\n" +
"matches the position preceding '\\n' or '\\r'.\r\n" +
"\r\n" +
"*\r\n" +
"  Matches the preceding character or subexpression zero or more times. For example, zo* matches \"z\" and \"zoo\".\r\n" +
"* is equivalent to {0,}.\r\n" +
"\r\n" +
"+\r\n" +
"  Matches the preceding character or subexpression one or more times. For example, 'zo+' matches \"zo\" and \"zoo\",\r\n" +
"but not \"z\". + is equivalent to {1,}.\r\n" +
"\r\n" +
".\r\n" +
"  Matches any single character except newline. To include newline in the match set, use a pattern like '[\\s\\S]'.\r\n" +
"\r\n" +
"\r\n" +
"Quantifiers:\r\n" +
"\r\n" +
"?\r\n" +
"  Optional match: matches the preceding symbol zero or one time. For example, 'do(es)?' matches the \"do\" in\r\n" +
"\"do\" or \"does\". ? is equivalent to {0,1}.\r\n" +
"  When this character immediately follows any of the other quantifiers (*, +, ?, {n}, {n,}, {n,m}), the preceding\r\n" +
"matching pattern is non-greedy. A non-greedy pattern matches as little of the searched string as possible,\r\n" +
"whereas the default greedy pattern matches as much of the searched string as possible. For example, in the string\r\n" +
"\"ooooo\", 'o+?' matches a single \"o\", while 'o+' matches all 'o's.\r\n" +
"\r\n" +
"{n} or {n,} or {,n} or {n,m}\r\n" +
"  These are quantifiers, where n and m are nonnegative integers (with n < m.) {n} matches the preceding symbol\r\n" +
"exactly n times. For example, 'o{2}' does not match the 'o' in \"Bob,\" but matches the two o's in \"food\". {n,}\r\n" +
"matches the preceding symbol at least n times, and {,n} matches the preceding symbol at most n times. {n,m}\r\n" +
"matches the preceding symbol at least n times and at most m times.\r\n" +
"  Note that by default, these operators are \"greedy\" - they will match the largest expression possible. With the\r\n" +
"string \"ooooo\", 'o{3,5}' will match all five o's. This behavior can be modified by appending a ? to the\r\n" +
"quantifier, which makes it \"non-greedy\" - it will match the fewest symbols possible. Again, with \"ooooo\",\r\n" +
"'o{3,5}?' will match only the first three o's.\r\n" +
"";
			txtReference.Select(0, 0);
		}

		private void RegularExpressionReference_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			bAlive = false;
		}

		#endregion

		#region Other functions

		public void MoveForm(int x, int y) {
			Show();
			Location = new Point(x, y);
			this.Refresh();
		}

		#endregion

	}
}
